## upx-ucl 3.00

=== src/Makefile ===
#
# UPX Makefile - needs GNU make 3.81 or better
#

MAKEFLAGS += -rR
.SUFFIXES:
export SHELL = /bin/sh
override e = $($1) $(EXTRA_$1) $(upx_$1) $($(basename $(notdir $@)).$1)

ifneq ($(findstring $(firstword $(MAKE_VERSION)),3.77 3.78 3.78.1 3.79 3.79.1 3.80),)
$(error GNU make 3.81 or better is required)
endif

ifndef srcdir
srcdir := $(dir $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST)))
srcdir := $(shell echo '$(srcdir)' | sed 's,/*$$,,')
endif
ifndef top_srcdir
top_srcdir := $(srcdir)/..
endif
include $(wildcard $(top_srcdir)/Makevars.global ./Makevars.local)
ifneq ($(srcdir),.)
##$(info Info: using VPATH . $(srcdir))
VPATH := . $(srcdir)
endif

ifeq ($(CXX),)
CXX = g++
endif
ifneq ($(findstring $(firstword $(CXX)),g++),)
USE_GNUC ?= 1
endif
ifeq ($(USE_GNUC),1)
ifeq ($(DEBUG),1)
CXXFLAGS += -O0 -g
else
CXXFLAGS += -O2
endif
CXXFLAGS += -Wall -W -Wcast-align -Wcast-qual -Wpointer-arith -Wwrite-strings -Werror
##CXXFLAGS += -Wshadow
endif
CPPFLAGS += $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES)
CXXLD ?= $(CXX)

exeext ?= .out
libext ?= .a
objext ?= .o

upx_SOURCES := $(wildcard $(srcdir)/*.cpp)
upx_OBJECTS := $(notdir $(upx_SOURCES:.cpp=$(objext)))

# we need UCL and zlib - you can set envvar UPX_UCLDIR
ifneq ($(wildcard $(UPX_UCLDIR)/include/ucl/ucl.h),)
INCLUDES += -I$(UPX_UCLDIR)/include
LIBS += $(addprefix -L,$(dir $(wildcard $(UPX_UCLDIR)/libucl$(libext) $(UPX_UCLDIR)/src/.libs/libucl$(libext))))
endif
LIBS += -lucl -lz
# you should set envvar UPX_LZMADIR to point to your unpacked lzma443.tar.bz2
ifneq ($(wildcard $(UPX_LZMADIR)/C/7zip/.),)
DEFS += -DWITH_LZMA=1
INCLUDES += -I$(UPX_LZMADIR)
endif


all: upx$(exeext) | .depend
.DELETE_ON_ERROR: upx$(exeext) $(upx_OBJECTS) .depend

upx$(exeext): $(upx_OBJECTS) $(upx_DEPENDENCIES)
	$($(notdir $@).PRE_LINK_STEP)
	$(strip $(CXXLD) $(call e,CPPFLAGS) $(call e,CXXFLAGS) $(call e,LDFLAGS) -o $@ $(upx_OBJECTS) $(call e,LDADD) $(call e,LIBS))
	$($(notdir $@).POST_LINK_STEP)

%.o : %.cpp | .depend
	$(strip $(CXX) $(call e,CPPFLAGS) $(call e,CXXFLAGS) -o $@ -c $<)

.depend: $(wildcard $(srcdir)/*.cpp $(srcdir)/*.h) $(MAKEFILE_LIST)
	@rm -f $@
ifeq ($(USE_GNUC),1)
	@echo "Updating $@"
	@$(strip $(CXX) $(call e,CPPFLAGS) -MM) $(filter %.cpp,$^) > $@
else
	touch $@
endif


ifeq ($(USE_GNUC),1)
##compress_lzma$(objext) : CXXFLAGS += -O3 -fomit-frame-pointer
compress_lzma$(objext) : CXXFLAGS += -Wno-cast-qual
compress_lzma$(objext) : CXXFLAGS += -Wno-non-virtual-dtor
compress_lzma$(objext) : CXXFLAGS += -Wno-shadow
compress_lzma$(objext) : CXXFLAGS += -Wno-unused
##compress_lzma$(objext) : CXXFLAGS += -Wno-error
endif


mostlyclean clean distclean maintainer-clean:
	rm -f *.d *.map *.o *.obj *.res .depend upx.exe upx.out upx.ttp upx$(exeext)

.PHONY: all mostlyclean clean distclean maintainer-clean

ifeq ($(MAKECMDGOALS),mostlyclean)
else ifeq ($(MAKECMDGOALS),clean)
else ifeq ($(MAKECMDGOALS),distclean)
else ifeq ($(MAKECMDGOALS),maintainer-clean)
else
-include .depend
endif

=== src/stub/Makefile ===
#
# UPX stub Makefile - needs GNU make 3.81 or better
#
# You also will need a number of special build tools like various
# cross-assemblers and cross-compilers - please see README.SRC
# for details.
#

MAKEFLAGS += -rR
.SUFFIXES:
.SECONDEXPANSION:
export LC_ALL = C
export SHELL = /bin/sh

# internal make variables
comma := ,
empty :=
space := $(empty) $(empty)
tab   := $(empty)	$(empty)

ifneq ($(findstring $(firstword $(MAKE_VERSION)),3.77 3.78 3.78.1 3.79 3.79.1 3.80),)
$(error GNU make 3.81 or better is required)
endif

ifndef srcdir
srcdir := $(dir $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST)))
srcdir := $(shell echo '$(srcdir)' | sed 's,/*$$,,')
endif
ifndef top_srcdir
top_srcdir := $(srcdir)/../..
endif
include $(wildcard $(top_srcdir)/Makevars.global ./Makevars.local)

# update $PATH for our special stub build tools
ifneq ($(wildcard $(HOME)/local/bin/bin-upx/.),)
export PATH := $(HOME)/local/bin/bin-upx:$(PATH)
endif
ifneq ($(wildcard $(HOME)/bin/bin-upx/.),)
export PATH := $(HOME)/bin/bin-upx:$(PATH)
endif


# /***********************************************************************
# //
# ************************************************************************/

ifndef STUBS
STUBS += amd64-linux.elf-entry.h
STUBS += amd64-linux.elf-fold.h
STUBS += amd64-linux.kernel.vmlinux.h
STUBS += amd64-linux.kernel.vmlinux-head.h
STUBS += amd64-linux.kernel.vmlinuz.h
STUBS += arm-linux.elf-entry.h
STUBS += arm-linux.elf-fold.h
STUBS += arm-linux.kernel.vmlinux.h
STUBS += arm-linux.kernel.vmlinux-head.h
STUBS += armeb-linux.elf-entry.h
STUBS += armeb-linux.elf-fold.h
STUBS += armeb-linux.kernel.vmlinux.h
STUBS += armeb-linux.kernel.vmlinux-head.h
STUBS += arm.v4a-wince.pe.h
STUBS += arm.v4t-wince.pe.h
STUBS += i086-dos16.com.h
STUBS += i086-dos16.exe.h
STUBS += i086-dos16.sys.h
STUBS += i386-bsd.elf-entry.h
STUBS += i386-bsd.elf-fold.h
STUBS += i386-bsd.elf.execve-entry.h
STUBS += i386-bsd.elf.execve-fold.h
STUBS += i386-darwin.macho-entry.h
STUBS += i386-darwin.macho-fold.h
STUBS += i386-openbsd.elf-fold.h
STUBS += i386-dos32.djgpp2.h
STUBS += i386-dos32.djgpp2-stubify.h
STUBS += i386-dos32.tmt.h
STUBS += i386-dos32.watcom.le.h
STUBS += i386-linux.elf-entry.h
STUBS += i386-linux.elf-fold.h
STUBS += i386-linux.elf.execve-entry.h
STUBS += i386-linux.elf.execve-fold.h
STUBS += i386-linux.elf.interp-entry.h
STUBS += i386-linux.elf.interp-fold.h
STUBS += i386-linux.elf.shell-entry.h
STUBS += i386-linux.elf.shell-fold.h
STUBS += i386-linux.kernel.vmlinux.h
STUBS += i386-linux.kernel.vmlinux-head.h
STUBS += i386-linux.kernel.vmlinuz.h
STUBS += i386-win32.pe.h
STUBS += m68k-atari.tos.h
STUBS += mipsel.r3000-ps1.h
STUBS += powerpc-darwin.macho-entry.h
STUBS += powerpc-darwin.macho-fold.h
STUBS += powerpc-linux.elf-entry.h
STUBS += powerpc-linux.elf-fold.h
endif


ifndef default.targets
ifeq ($(wildcard .all-stamp),)
default.targets =
default:
	@echo "UPX info: type 'make all' if you have all the required build tools."
else
default.targets = all
default: $$(default.targets)
endif
endif


all.targets ?= .upx-stubtools-stamp tmp/.tmp-stamp .all-stamp
all: $$(all.targets)
.upx-stubtools-stamp: $(MAKEFILE_LIST)
	upx-stubtools-check-version 20060823
	@echo "timestamp" > $@
%/.tmp-stamp:
	@mkdir -p $(dir $@)
	@echo "timestamp" > $@
.PRECIOUS: %/.tmp-stamp
.all-stamp: $$(STUBS)
	@echo "timestamp" > $@

ifeq ($(wildcard .all-stamp),)
mostlyclean clean: distclean
else
mostlyclean clean: maintainer-clean
endif
distclean:
	rm -f .*-stamp
	rm -rf tmp
maintainer-clean:
	rm -f .upx-stubtools-stamp
	rm -rf tmp
	rm -f $(STUBS)

.PHONY: default all mostlyclean clean distclean maintainer-clean


# util var for use in the rules - basename of the current target
override T = $(basename $(notdir $@))

# clear some vars, just in case
LABEL_PREFIX =
PP_FLAGS =
tc_bfdarch =
tc_bfdname =
tc_list =
tc_objdump_disasm_options =

# commands
PYTHON     = python
UNIX2DOS  := perl -i -pe 's/$$/\r/;'

# trim (strip) trailing whitespace
RTRIM     := sed -e 's/[ $(tab)]*$$//'
# squeeze duplicate blank lines, delete empty first & last line
BLSQUEEZE := $(RTRIM) | cat --squeeze-blank | sed -e '1{/^$$/d}' -e '$${/^$$/d}'
# delete blank lines
BLDEL     := $(RTRIM) | sed -e '/^$$/d'
# delete blank lines at top (beginning) of file
BLDELTOP  := sed -e '/./,$$!d'
# delete blank lines at bottom (end) of file
BLDELBOT  := sed -e ':a' -e '/^\n*$$/{$$d;N;ba' -e '}'


# /***********************************************************************
# // setup toolchain globals
# ************************************************************************/

# enumerate the names of all variables that will get tested (from basename and $(tc_list))
__tc_varlist   = tc.$(basename $(notdir $@)).$1 $(foreach v,$(tc_list),tc.$v.$1)
# return the name of the first variable that is not empty
__tc_varsearch = $(firstword $(foreach v,$1,$(if $($v),$v,)))
# error sentinel for missing commands
__tc_FALSE     = false tc_FALSE: '1:$1 2:$2 3:$3 4:$4 5:$5' '$@' '$<' '$(tc_list)'
# call (expand) the first variable that is not empty
  # [move the next line within the "tc" macro for debugging]
  # tc debug '1:$1 2:$2 3:$3 4:$4 5:$5' '$@' '$<' '$(tc_list)'
define tc
  $(call $(call __tc_varsearch,$(call __tc_varlist,$1) __tc_FALSE),$2,$3,$4,$5)
endef

# default tools
tc.default.bin2h      = $(PYTHON) $(top_srcdir)/src/stub/scripts/bin2h.py --ident=auto-stub
##tc.default.bin2h-c    = $(call tc,bin2h) --compress=14,15,0
tc.default.bin2h-c    = $(call tc,bin2h) --compress=0
tc.default.brandelf   = $(PYTHON) $(top_srcdir)/src/stub/scripts/brandelf.py $(if $(tc_bfdname),--bfdname=$(tc_bfdname))
tc.default.gpp_inc    = $(PYTHON) $(top_srcdir)/src/stub/scripts/gpp_inc.py
tc.default.gpp_mkdep  = $(PYTHON) $(top_srcdir)/src/stub/scripts/gpp_inc.py -o /dev/null
tc.default.pp-as      = i386-linux-gcc-3.4.6 -E -nostdinc -x assembler-with-cpp -Wall
tc.default.sstrip     = sstrip
tc.default.xstrip     = $(PYTHON) $(top_srcdir)/src/stub/scripts/xstrip.py

# default multiarch-binutils
tc.default.m-ar       = multiarch-ar-2.17
tc.default.m-ld       = multiarch-ld-2.17 $(if $(tc_bfdname),-b $(tc_bfdname))
tc.default.m-nm       = multiarch-nm-2.17 $(if $(tc_bfdname),--target=$(tc_bfdname))
tc.default.m-objcopy  = multiarch-objcopy-2.17 $(if $(tc_bfdname),-F $(tc_bfdname))
tc.default.m-objdump  = multiarch-objdump-2.17 $(if $(tc_bfdname),-b $(tc_bfdname)) $(if $(tc_bfdarch),-m $(tc_bfdarch))
tc.default.m-readelf  = multiarch-readelf-2.17

# default binutils
tc.default.ld         = $(call tc,m-ld)
tc.default.nm         = $(call tc,m-nm)
tc.default.objcopy    = $(call tc,m-objcopy)
tc.default.objdump    = $(call tc,m-objdump)
tc.default.readelf    = $(call tc,m-readelf)

# default binutils functions
define tc.default.f-embed_objinfo
	chmod a-x $1
	$(call tc,objcopy) --strip-unneeded $1
	$(call tc,objcopy) -R .text -R .data -R .bss $1
	$(call tc,objcopy) -R .comment -R .note -R .note.GNU-stack -R .reginfo $1
	$(call tc,objdump) -Dr $(tc_objdump_disasm_options) $1 | $(RTRIM) > $1.disasm
	$(call tc,objdump) -htr -w $1 | $(BLSQUEEZE) > $1.dump
	$(call tc,xstrip) --with-dump=$1.dump --create-bindump=$1.bindump $1
	cat $1.dump >> $1
endef
define tc.default.f-objstrip
	chmod a-x $1
	$(call tc,objcopy) -R .comment -R .note -R .note.GNU-stack -R .reginfo $1
endef

# some common arch settings
tc.arch-i086.gcc      = i386-linux-gcc-3.4.6 -m32 -march=i386 -nostdinc -MMD -MT $@
tc.arch-i086.wdis     = $(WATCOM)/binl/wdis
tc.arch-i386.gcc      = i386-linux-gcc-3.4.6 -m32 -march=i386 -nostdinc -MMD -MT $@
tc.arch-i386.djasm    = djasm


# /***********************************************************************
# // amd64-linux.elf
# ************************************************************************/

amd64-linux.elf%.h : tc_list = amd64-linux.elf default
amd64-linux.elf%.h : tc_bfdname = elf64-x86-64

tc.amd64-linux.elf.gcc  = amd64-linux-gcc-3.4.4 -m64 -nostdinc -MMD -MT $@
tc.amd64-linux.elf.gcc += -fno-exceptions -fno-asynchronous-unwind-tables
tc.amd64-linux.elf.gcc += -Wall -W -Wcast-align -Wcast-qual -Wwrite-strings -Werror

amd64-linux.elf-entry.h: $(srcdir)/src/$$T.S
	$(call tc,gcc) -c -x assembler-with-cpp $< -o tmp/$T.bin
	$(call tc,f-embed_objinfo,tmp/$T.bin)
	$(call tc,bin2h) tmp/$T.bin $@

amd64-linux.elf-fold.h : tmp/$$T.o tmp/amd64-linux.elf-main.o $(srcdir)/src/$$T.lds
	$(call tc,ld) --strip-all -T $(srcdir)/src/$T.lds -Map tmp/$T.map $(filter %.o,$^) -o tmp/$T.bin
	$(call tc,f-objstrip,tmp/$T.bin)
	$(call tc,sstrip) tmp/$T.bin
	$(call tc,bin2h) tmp/$T.bin $@

tmp/amd64-linux.elf-fold.o : $(srcdir)/src/$$T.S
	$(call tc,gcc) -c $< -o $@
	$(call tc,f-objstrip,$@)

tmp/amd64-linux.elf-main.o : $(srcdir)/src/$$T.c
	$(call tc,gcc) -c -Os $< -o $@
	$(call tc,f-objstrip,$@)
	$(call tc,objdump) -dr $(tc_objdump_disasm_options) $@ | $(RTRIM) > $@.disasm


# /***********************************************************************
# // amd64-linux.kernel.vmlinux
# // amd64-linux.kernel.vmlinuz
# // amd64-linux.kernel.vmlinux-head
# ************************************************************************/

# info: we use the tc settings from arch-i386 !!

amd64-linux.kernel.vmlinu%.h : tc_list = arch-i386 default
amd64-linux.kernel.vmlinu%.h : tc_bfdname = elf32-i386

amd64-linux.kernel.vmlinu%.h : $(srcdir)/src/$$T.S
	$(call tc,gcc) -c -x assembler-with-cpp $< -o tmp/$T.bin
	$(call tc,f-embed_objinfo,tmp/$T.bin)
	$(call tc,bin2h-c) tmp/$T.bin $@

amd64-linux.kernel.vmlinux-head.h : $(srcdir)/src/$$T.S
	$(call tc,gcc) -c -x assembler-with-cpp $< -o tmp/$T.o
	$(call tc,objcopy) --output-target binary --only-section .text tmp/$T.o tmp/$T.bin
	$(call tc,bin2h) tmp/$T.bin $@


# /***********************************************************************
# // arm-linux.elf
# ************************************************************************/

arm-linux.elf%.h : tc_list = arm-linux.elf default
arm-linux.elf%.h : tc_bfdname = elf32-littlearm

tc.arm-linux.elf.gcc  = arm-linux-gcc-4.1.0 -march=armv4 -nostdinc -MMD -MT $@
tc.arm-linux.elf.gcc += -fno-exceptions -fno-asynchronous-unwind-tables
tc.arm-linux.elf.gcc += -Wall -W -Wcast-align -Wcast-qual -Wwrite-strings -Werror

arm-linux.elf-entry.h : $(srcdir)/src/$$T.S
	$(call tc,gcc) -march=armv4 -c $< -o tmp/$T.bin
	$(call tc,f-embed_objinfo,tmp/$T.bin)
	$(call tc,bin2h) tmp/$T.bin $@

arm-linux.elf-fold.h : tmp/$$T.o tmp/arm-linux.elf-main.o $(srcdir)/src/$$T.lds
	$(call tc,ld) --strip-all -T $(srcdir)/src/$T.lds -Map tmp/$T.map $(filter %.o,$^) -o tmp/$T.bin
	$(call tc,f-objstrip,tmp/$T.bin)
	$(call tc,sstrip) tmp/$T.bin
	$(call tc,bin2h) tmp/$T.bin $@

tmp/arm-linux.elf-fold.o : $(srcdir)/src/$$T.S
	$(call tc,gcc) -c $< -o $@
	$(call tc,f-objstrip,$@)

tmp/arm-linux.elf-main.o : $(srcdir)/src/$$T.c
	$(call tc,gcc) -c -Os $< -o $@
	$(call tc,f-objstrip,$@)
	$(call tc,objdump) -dr $(tc_objdump_disasm_options) $@ | $(RTRIM) > $@.disasm


# /***********************************************************************
# // arm-linux.kernel.vmlinux
# // arm-linux.kernel.vmlinuz
# // arm-linux.kernel.vmlinux-head
# ************************************************************************/

arm-linux.kernel.vmlinu%.h : tc_list = arm-linux.kernel default
arm-linux.kernel.vmlinu%.h : tc_bfdname = elf32-littlearm

tc.arm-linux.kernel.gcc  = arm-linux-gcc-4.1.0 -march=armv5 -nostdinc -MMD -MT $@
tc.arm-linux.kernel.gcc += -fno-exceptions -fno-asynchronous-unwind-tables
tc.arm-linux.kernel.gcc += -Wall -W -Wcast-align -Wcast-qual -Wwrite-strings -Werror

arm-linux.kernel.vmlinu%.h : $(srcdir)/src/$$T.S
	$(call tc,gcc) -c -x assembler-with-cpp $< -o tmp/$T.bin
	$(call tc,f-embed_objinfo,tmp/$T.bin)
	$(call tc,bin2h-c) tmp/$T.bin $@

arm-linux.kernel.vmlinux-head.h : $(srcdir)/src/$$T.S
	$(call tc,gcc) -c -x assembler-with-cpp $< -o tmp/$T.o
	$(call tc,objcopy) --output-target binary --only-section .text tmp/$T.o tmp/$T.bin
	$(call tc,bin2h) tmp/$T.bin $@


# /***********************************************************************

## upx-ucl 3.01

=== Makefile ===
#
# UPX toplevel Makefile - needs GNU make 3.81 or better
#

MAKEFLAGS += -rR
.SUFFIXES:
export SHELL = /bin/sh

ifneq ($(findstring $(firstword $(MAKE_VERSION)),3.77 3.78 3.78.1 3.79 3.79.1 3.80),)
$(error GNU make 3.81 or better is required)
endif

srcdir = .
top_srcdir = .
include $(wildcard $(top_srcdir)/Makevars.global ./Makevars.local)


# info: src/stub needs special build tools
BUILD_STUB = 0
ifneq ($(wildcard $(HOME)/local/bin/bin-upx/.),)
BUILD_STUB = 1
endif
ifneq ($(wildcard $(HOME)/bin/bin-upx/.),)
BUILD_STUB = 1
endif


default:
	@echo "UPX info: please choose a target for 'make'"

all mostlyclean clean distclean maintainer-clean:
ifeq ($(BUILD_STUB),1)
	$(MAKE) -C src/stub $@
endif
	$(MAKE) -C src $@
	$(MAKE) -C doc $@


ifneq ($(wildcard .hg/data/.),)
# automatically generate ChangeLog from local Mercurial repo
ChangeLog:
	hg log --style=changelog > $@
.PHONY: ChangeLog
endif


.PHONY: default all mostlyclean clean distclean maintainer-clean

=== src/Makefile ===
--- 
+++ 
@@ -55,9 +55,10 @@
 LIBS += $(addprefix -L,$(dir $(wildcard $(UPX_UCLDIR)/libucl$(libext) $(UPX_UCLDIR)/src/.libs/libucl$(libext))))
 endif
 LIBS += -lucl -lz
-# you should set envvar UPX_LZMADIR to point to your unpacked lzma443.tar.bz2
-ifneq ($(wildcard $(UPX_LZMADIR)/C/7zip/.),)
-DEFS += -DWITH_LZMA=1
+# you should set envvar UPX_LZMADIR to point to your unpacked LZMA SDK
+include $(top_srcdir)/src/stub/src/c/Makevars.lzma
+ifneq ($(UPX_LZMA_VERSION),)
+DEFS += -DWITH_LZMA=$(UPX_LZMA_VERSION)
 INCLUDES += -I$(UPX_LZMADIR)
 endif
 
@@ -86,10 +87,13 @@
 ifeq ($(USE_GNUC),1)
 ##compress_lzma$(objext) : CXXFLAGS += -O3 -fomit-frame-pointer
 compress_lzma$(objext) : CXXFLAGS += -Wno-cast-qual
+compress_lzma$(objext) : CXXFLAGS += -Wno-shadow
+ifeq ($(UPX_LZMA_VERSION),0x443)
 compress_lzma$(objext) : CXXFLAGS += -Wno-non-virtual-dtor
-compress_lzma$(objext) : CXXFLAGS += -Wno-shadow
 compress_lzma$(objext) : CXXFLAGS += -Wno-unused
-##compress_lzma$(objext) : CXXFLAGS += -Wno-error
+endif
+# needed for gcc-4.3:
+compress_lzma$(objext) : CXXFLAGS += -Wno-error
 endif

=== src/stub/Makefile ===
--- 
+++ 
@@ -9,6 +9,7 @@
 MAKEFLAGS += -rR
 .SUFFIXES:
 .SECONDEXPANSION:
+.NOTPARALLEL:
 export LC_ALL = C
 export SHELL = /bin/sh
 
@@ -88,10 +89,14 @@
 STUBS += i386-win32.pe.h
 STUBS += m68k-atari.tos.h
 STUBS += mipsel.r3000-ps1.h
+STUBS += mipsel.r3000-linux.elf-entry.h
+STUBS += mipsel.r3000-linux.elf-fold.h
 STUBS += powerpc-darwin.macho-entry.h
 STUBS += powerpc-darwin.macho-fold.h
 STUBS += powerpc-linux.elf-entry.h
 STUBS += powerpc-linux.elf-fold.h
+STUBS += powerpc-linux.kernel.vmlinux.h
+STUBS += powerpc-linux.kernel.vmlinux-head.h
 endif
 
 
@@ -147,8 +152,11 @@
 tc_objdump_disasm_options =
 
 # commands
+ECHO_e     = /bin/echo -e
+ECHO_E     = /bin/echo -E
+PERL       = perl
 PYTHON     = python
-UNIX2DOS  := perl -i -pe 's/$$/\r/;'
+UNIX2DOS  := $(PERL) -i -pe 's/$$/\r/;'
 
 # trim (strip) trailing whitespace
 RTRIM     := sed -e 's/[ $(tab)]*$$//'
@@ -237,7 +245,7 @@
 
 tc.amd64-linux.elf.gcc  = amd64-linux-gcc-3.4.4 -m64 -nostdinc -MMD -MT $@
 tc.amd64-linux.elf.gcc += -fno-exceptions -fno-asynchronous-unwind-tables
-tc.amd64-linux.elf.gcc += -Wall -W -Wcast-align -Wcast-qual -Wwrite-strings -Werror
+tc.amd64-linux.elf.gcc += -Wall -W -Wcast-align -Wcast-qual -Wstrict-prototypes -Wwrite-strings -Werror
 
 amd64-linux.elf-entry.h: $(srcdir)/src/$$T.S
 	$(call tc,gcc) -c -x assembler-with-cpp $< -o tmp/$T.bin
@@ -291,7 +299,7 @@
 
 tc.arm-linux.elf.gcc  = arm-linux-gcc-4.1.0 -march=armv4 -nostdinc -MMD -MT $@
 tc.arm-linux.elf.gcc += -fno-exceptions -fno-asynchronous-unwind-tables
-tc.arm-linux.elf.gcc += -Wall -W -Wcast-align -Wcast-qual -Wwrite-strings -Werror
+tc.arm-linux.elf.gcc += -Wall -W -Wcast-align -Wcast-qual -Wstrict-prototypes -Wwrite-strings -Werror
 
 arm-linux.elf-entry.h : $(srcdir)/src/$$T.S
 	$(call tc,gcc) -march=armv4 -c $< -o tmp/$T.bin
@@ -325,17 +333,10 @@
 
 tc.arm-linux.kernel.gcc  = arm-linux-gcc-4.1.0 -march=armv5 -nostdinc -MMD -MT $@
 tc.arm-linux.kernel.gcc += -fno-exceptions -fno-asynchronous-unwind-tables
-tc.arm-linux.kernel.gcc += -Wall -W -Wcast-align -Wcast-qual -Wwrite-strings -Werror
+tc.arm-linux.kernel.gcc += -Wall -W -Wcast-align -Wcast-qual -Wstrict-prototypes -Wwrite-strings -Werror
 
 arm-linux.kernel.vmlinu%.h : $(srcdir)/src/$$T.S
 	$(call tc,gcc) -c -x assembler-with-cpp $< -o tmp/$T.bin
 	$(call tc,f-embed_objinfo,tmp/$T.bin)
 	$(call tc,bin2h-c) tmp/$T.bin $@
 
-arm-linux.kernel.vmlinux-head.h : $(srcdir)/src/$$T.S
-	$(call tc,gcc) -c -x assembler-with-cpp $< -o tmp/$T.o
-	$(call tc,objcopy) --output-target binary --only-section .text tmp/$T.o tmp/$T.bin
-	$(call tc,bin2h) tmp/$T.bin $@
-
-
-# /***********************************************************************

=== src/stub/tools/armpe/Makefile ===
#  Makefile for armpe_tester

MAKEFLAGS += -rR
SHELL = /bin/sh

# update path for our special stub build tools
ifneq ($(wildcard $(HOME)/local/bin/bin-upx),)
export PATH := $(HOME)/local/bin/bin-upx:$(PATH)
endif

ifneq ($(wildcard $(HOME)/bin/bin-upx),)
export PATH := $(HOME)/bin/bin-upx:$(PATH)
endif


all: armpe_tester wtest.exe

armpe_tester: armpe_tester.c
	arm-9tdmi-linux-gnu-gcc -Wl,--section-start,.interp=0x1000 -g -Wall -W -o $@ $<

wtest.exe:  armpe_tester.c
	arm-wince-pe-gcc -Wl,--image-base,0x400000 -s -Wall -W -o $@ $<

mostlyclean clean distclean maintainer-clean:
	rm -f *.d *.o *.obj
	rm -f  armpe_tester wtest.exe

.PHONY: all mostlyclean clean distclean maintainer-clean

## upx-ucl 3.05

=== src/Makefile ===
--- 
+++ 
@@ -1,5 +1,7 @@
 #
 # UPX Makefile - needs GNU make 3.81 or better
+#
+# Copyright (C) 1996-2010 Markus Franz Xaver Johannes Oberhumer
 #
 
 MAKEFLAGS += -rR
@@ -36,8 +38,9 @@
 else
 CXXFLAGS += -O2
 endif
-CXXFLAGS += -Wall -W -Wcast-align -Wcast-qual -Wpointer-arith -Wwrite-strings -Werror
-##CXXFLAGS += -Wshadow
+CXXFLAGS_WERROR = -Werror
+CXXFLAGS += -Wall -W -Wcast-align -Wcast-qual -Wpointer-arith -Wshadow -Wwrite-strings
+CXXFLAGS += $(CXXFLAGS_WERROR)
 endif
 CPPFLAGS += $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES)
 CXXLD ?= $(CXX)

=== src/stub/Makefile ===
--- 
+++ 
@@ -5,6 +5,8 @@
 # cross-assemblers and cross-compilers - please see README.SRC
 # for details.
 #
+# Copyright (C) 1996-2010 Markus Franz Xaver Johannes Oberhumer
+#
 
 MAKEFLAGS += -rR
 .SUFFIXES:
@@ -46,19 +48,30 @@
 # ************************************************************************/
 
 ifndef STUBS
+STUBS += amd64-darwin.dylib-entry.h
+STUBS += amd64-darwin.macho-entry.h
+STUBS += amd64-darwin.macho-fold.h
 STUBS += amd64-linux.elf-entry.h
 STUBS += amd64-linux.elf-fold.h
 STUBS += amd64-linux.kernel.vmlinux.h
 STUBS += amd64-linux.kernel.vmlinux-head.h
-STUBS += amd64-linux.kernel.vmlinuz.h
+STUBS += amd64-linux.shlib-init.h
+STUBS += armel-eabi-linux.elf-entry.h
+STUBS += armel-eabi-linux.elf-fold.h
+STUBS += armel-eabi-linux.shlib-init.h
+STUBS += arm-darwin.macho-entry.h
+STUBS += arm-darwin.macho-fold.h
 STUBS += arm-linux.elf-entry.h
 STUBS += arm-linux.elf-fold.h
 STUBS += arm-linux.kernel.vmlinux.h
 STUBS += arm-linux.kernel.vmlinux-head.h
+STUBS += arm-linux.shlib-init.h
 STUBS += armeb-linux.elf-entry.h
 STUBS += armeb-linux.elf-fold.h
 STUBS += armeb-linux.kernel.vmlinux.h
 STUBS += armeb-linux.kernel.vmlinux-head.h
+STUBS += armel-linux.kernel.vmlinuz.h
+STUBS += armel-linux.kernel.vmlinuz-head.h
 STUBS += arm.v4a-wince.pe.h
 STUBS += arm.v4t-wince.pe.h
 STUBS += i086-dos16.com.h
@@ -68,6 +81,8 @@
 STUBS += i386-bsd.elf-fold.h
 STUBS += i386-bsd.elf.execve-entry.h
 STUBS += i386-bsd.elf.execve-fold.h
+STUBS += i386-darwin.dylib-entry.h
+# STUBS += i386-darwin.dylib-fold.h
 STUBS += i386-darwin.macho-entry.h
 STUBS += i386-darwin.macho-fold.h
 STUBS += i386-openbsd.elf-fold.h
@@ -86,17 +101,22 @@
 STUBS += i386-linux.kernel.vmlinux.h
 STUBS += i386-linux.kernel.vmlinux-head.h
 STUBS += i386-linux.kernel.vmlinuz.h
+STUBS += i386-linux.shlib-init.h
 STUBS += i386-win32.pe.h
 STUBS += m68k-atari.tos.h
-STUBS += mipsel.r3000-ps1.h
+STUBS += mips.r3000-linux.elf-entry.h
+STUBS += mips.r3000-linux.elf-fold.h
 STUBS += mipsel.r3000-linux.elf-entry.h
 STUBS += mipsel.r3000-linux.elf-fold.h
+STUBS += mipsel.r3000-ps1.h
+STUBS += powerpc-darwin.dylib-entry.h
 STUBS += powerpc-darwin.macho-entry.h
 STUBS += powerpc-darwin.macho-fold.h
 STUBS += powerpc-linux.elf-entry.h
 STUBS += powerpc-linux.elf-fold.h
 STUBS += powerpc-linux.kernel.vmlinux.h
 STUBS += powerpc-linux.kernel.vmlinux-head.h
+STUBS += thumb-eabi-linux.shlib-init.h
 endif
 
 
@@ -181,7 +201,7 @@
 # error sentinel for missing commands
 __tc_FALSE     = false tc_FALSE: '1:$1 2:$2 3:$3 4:$4 5:$5' '$@' '$<' '$(tc_list)'
 # call (expand) the first variable that is not empty
-  # [move the next line within the "tc" macro for debugging]
+  # [move the next comment line within the "tc" macro for debugging]
   # tc debug '1:$1 2:$2 3:$3 4:$4 5:$5' '$@' '$<' '$(tc_list)'
 define tc
   $(call $(call __tc_varsearch,$(call __tc_varlist,$1) __tc_FALSE),$2,$3,$4,$5)
@@ -220,7 +240,7 @@
 	$(call tc,objcopy) -R .text -R .data -R .bss $1
 	$(call tc,objcopy) -R .comment -R .note -R .note.GNU-stack -R .reginfo $1
 	$(call tc,objdump) -Dr $(tc_objdump_disasm_options) $1 | $(RTRIM) > $1.disasm
-	$(call tc,objdump) -htr -w $1 | $(BLSQUEEZE) > $1.dump
+	$(call tc,objdump) -htr -w $1 | $(BLSQUEEZE) | sed -e '1s/^.*: *file format/file format/' > $1.dump
 	$(call tc,xstrip) --with-dump=$1.dump --create-bindump=$1.bindump $1
 	cat $1.dump >> $1
 endef
@@ -237,6 +257,49 @@
 
 
 # /***********************************************************************
+# // amd64-darwin.dylib
+# ************************************************************************/
+
+# info: we use the tc settings from amd64-linux.elf
+amd64-darwin.dylib%.h : tc_list = amd64-linux.elf default
+amd64-darwin.dylib%.h : tc_bfdname = elf64-x86-64
+
+## All code is in dylib-entry.  There is no dylib-fold, no dylib-main.
+amd64-darwin.dylib-entry.h : $(srcdir)/src/$$T.S
+	$(call tc,gcc) -c $< -o tmp/$T.bin
+	$(call tc,f-embed_objinfo,tmp/$T.bin)
+	$(call tc,bin2h) tmp/$T.bin $@
+
+
+# /***********************************************************************
+# // amd64-darwin.macho
+# ************************************************************************/
+
+# info: we use the tc settings from amd64-linux.elf
+amd64-darwin.macho%.h : tc_list = amd64-linux.elf default
+amd64-darwin.macho%.h : tc_bfdname = elf64-x86-64
+
+amd64-darwin.macho-entry.h : $(srcdir)/src/$$T.S
+	$(call tc,gcc) -c $< -o tmp/$T.bin
+	$(call tc,f-embed_objinfo,tmp/$T.bin)
+	$(call tc,bin2h) tmp/$T.bin $@
+
+amd64-darwin.macho-fold.h : tmp/$$T.o tmp/amd64-darwin.macho-main.o
+	$(call tc,ld) --no-warn-mismatch --strip-all --oformat binary -Map tmp/$T.map $(filter %.o,$^) -o tmp/$T.bin
+	chmod a-x tmp/$T.bin
+	$(call tc,bin2h) tmp/$T.bin $@
+
+tmp/amd64-darwin.macho-fold.o : $(srcdir)/src/$$T.S
+	$(call tc,gcc) -c $< -o $@
+	$(call tc,f-objstrip,$@)
+
+tmp/amd64-darwin.macho-main.o : $(srcdir)/src/$$T.c
+	$(call tc,gcc) -c -Os $< -o $@
+	$(call tc,f-objstrip,$@)
+	$(call tc,objdump) -dr $(tc_objdump_disasm_options) $@ | $(RTRIM) > $@.disasm
+
+
+# /***********************************************************************
 # // amd64-linux.elf
 # ************************************************************************/
 
@@ -253,7 +316,9 @@
 	$(call tc,bin2h) tmp/$T.bin $@
 
 amd64-linux.elf-fold.h : tmp/$$T.o tmp/amd64-linux.elf-main.o $(srcdir)/src/$$T.lds
-	$(call tc,ld) --strip-all -T $(srcdir)/src/$T.lds -Map tmp/$T.map $(filter %.o,$^) -o tmp/$T.bin
+#	# FIXME: multiarch-ld-2.18 creates a huge file here, so use 2.17
+#	####$(call tc,ld) --strip-all -T $(srcdir)/src/$T.lds -Map tmp/$T.map $(filter %.o,$^) -o tmp/$T.bin
+	multiarch-ld-2.17 --strip-all -T $(srcdir)/src/$T.lds -Map tmp/$T.map $(filter %.o,$^) -o tmp/$T.bin
 	$(call tc,f-objstrip,tmp/$T.bin)
 	$(call tc,sstrip) tmp/$T.bin
 	$(call tc,bin2h) tmp/$T.bin $@
@@ -270,73 +335,9 @@
 
 # /***********************************************************************
 # // amd64-linux.kernel.vmlinux
-# // amd64-linux.kernel.vmlinuz
 # // amd64-linux.kernel.vmlinux-head
 # ************************************************************************/
 
 # info: we use the tc settings from arch-i386 !!
 
 amd64-linux.kernel.vmlinu%.h : tc_list = arch-i386 default
-amd64-linux.kernel.vmlinu%.h : tc_bfdname = elf32-i386
-
-amd64-linux.kernel.vmlinu%.h : $(srcdir)/src/$$T.S
-	$(call tc,gcc) -c -x assembler-with-cpp $< -o tmp/$T.bin
-	$(call tc,f-embed_objinfo,tmp/$T.bin)
-	$(call tc,bin2h-c) tmp/$T.bin $@
-
-amd64-linux.kernel.vmlinux-head.h : $(srcdir)/src/$$T.S
-	$(call tc,gcc) -c -x assembler-with-cpp $< -o tmp/$T.o
-	$(call tc,objcopy) --output-target binary --only-section .text tmp/$T.o tmp/$T.bin
-	$(call tc,bin2h) tmp/$T.bin $@
-
-
-# /***********************************************************************
-# // arm-linux.elf
-# ************************************************************************/
-
-arm-linux.elf%.h : tc_list = arm-linux.elf default
-arm-linux.elf%.h : tc_bfdname = elf32-littlearm
-
-tc.arm-linux.elf.gcc  = arm-linux-gcc-4.1.0 -march=armv4 -nostdinc -MMD -MT $@
-tc.arm-linux.elf.gcc += -fno-exceptions -fno-asynchronous-unwind-tables
-tc.arm-linux.elf.gcc += -Wall -W -Wcast-align -Wcast-qual -Wstrict-prototypes -Wwrite-strings -Werror
-
-arm-linux.elf-entry.h : $(srcdir)/src/$$T.S
-	$(call tc,gcc) -march=armv4 -c $< -o tmp/$T.bin
-	$(call tc,f-embed_objinfo,tmp/$T.bin)
-	$(call tc,bin2h) tmp/$T.bin $@
-
-arm-linux.elf-fold.h : tmp/$$T.o tmp/arm-linux.elf-main.o $(srcdir)/src/$$T.lds
-	$(call tc,ld) --strip-all -T $(srcdir)/src/$T.lds -Map tmp/$T.map $(filter %.o,$^) -o tmp/$T.bin
-	$(call tc,f-objstrip,tmp/$T.bin)
-	$(call tc,sstrip) tmp/$T.bin
-	$(call tc,bin2h) tmp/$T.bin $@
-
-tmp/arm-linux.elf-fold.o : $(srcdir)/src/$$T.S
-	$(call tc,gcc) -c $< -o $@
-	$(call tc,f-objstrip,$@)
-
-tmp/arm-linux.elf-main.o : $(srcdir)/src/$$T.c
-	$(call tc,gcc) -c -Os $< -o $@
-	$(call tc,f-objstrip,$@)
-	$(call tc,objdump) -dr $(tc_objdump_disasm_options) $@ | $(RTRIM) > $@.disasm
-
-
-# /***********************************************************************
-# // arm-linux.kernel.vmlinux
-# // arm-linux.kernel.vmlinuz
-# // arm-linux.kernel.vmlinux-head
-# ************************************************************************/
-
-arm-linux.kernel.vmlinu%.h : tc_list = arm-linux.kernel default
-arm-linux.kernel.vmlinu%.h : tc_bfdname = elf32-littlearm
-
-tc.arm-linux.kernel.gcc  = arm-linux-gcc-4.1.0 -march=armv5 -nostdinc -MMD -MT $@
-tc.arm-linux.kernel.gcc += -fno-exceptions -fno-asynchronous-unwind-tables
-tc.arm-linux.kernel.gcc += -Wall -W -Wcast-align -Wcast-qual -Wstrict-prototypes -Wwrite-strings -Werror
-
-arm-linux.kernel.vmlinu%.h : $(srcdir)/src/$$T.S
-	$(call tc,gcc) -c -x assembler-with-cpp $< -o tmp/$T.bin
-	$(call tc,f-embed_objinfo,tmp/$T.bin)
-	$(call tc,bin2h-c) tmp/$T.bin $@
-

=== debian/changelog ===
upx-ucl (3.05-1ubuntu1) maverick; urgency=low

  * Merge from debian unstable. (LP: #603122) Remaining changes:
    - [arm] needs porting to thumb2; use -marm as the code
      does a lot of low level hacking not yet ready for thumb2 
      (LP: #514254)

 -- Bhavani Shankar <bhavi@ubuntu.com>  Thu, 08 Jul 2010 13:40:54 +0530

upx-ucl (3.05-1) unstable; urgency=low

  * New upstream release.
  * Switch to the `3.0 (quilt)' source format:
    + split previous changes into two patches: 00_Makefile.patch
      and 01_documentation.patch.
  * Standards-Version: 3.8.4 (no changes).

 -- Robert Luberda <robert@debian.org>  Sat, 12 Jun 2010 16:21:24 +0200

upx-ucl (3.04-1ubuntu1) lucid; urgency=low

  * fix LP: #514254 - [arm] needs porting to thumb2; use -marm as the code
    does a lot of low level hacking not yet ready for thumb2 

 -- Alexander Sack <asac@ubuntu.com>  Mon, 12 Apr 2010 15:24:02 +0200

upx-ucl (3.04-1) unstable; urgency=low

  * New upstream release:
    + FTBFS with gcc 4.4 fixed by upstream (closes: #548566).
  * p_mach.cpp: Fix from upstream vcs: mach/fat needs seek() 
    after set_extent().

 -- Robert Luberda <robert@debian.org>  Fri, 16 Oct 2009 12:56:47 +0200

upx-ucl (3.03-3) unstable; urgency=low

  * Upload to unstable.
  * Standards-Version: 3.8.3 (no changes).
  * Build with debhelper v7.
  * rules: call dh_prep instead of `dh_clean -k'.

 -- Robert Luberda <robert@debian.org>  Sun, 20 Sep 2009 21:34:57 +0200

upx-ucl (3.03-2) experimental; urgency=low

  * Merge changes from 3.01-2.1 and 3.01-3.

 -- Robert Luberda <robert@debian.org>  Sun, 27 Jul 2008 23:38:45 +0200

upx-ucl (3.03-1) experimental; urgency=low

  * New upstream release.
  * Fix bashism in debian/rules (closes: #478635).

 -- Robert Luberda <robert@debian.org>  Tue, 29 Apr 2008 23:01:31 +0200

upx-ucl (3.02-2) experimental; urgency=low

  * Merge changes from 3.01-2.

 -- Robert Luberda <robert@debian.org>  Sun, 27 Apr 2008 09:37:26 +0200

upx-ucl (3.02-1) experimental; urgency=low

  * New upstream version.
  * Standards-Version: 3.7.3 (no changes).
  * Move homepage url from Description to its own field.

 -- Robert Luberda <robert@debian.org>  Sat, 05 Jan 2008 10:03:36 +0100

upx-ucl (3.01-3) unstable; urgency=low

  * Applied patch from Ubuntu to fix ftbfs due to "format not a string 
    literal and no format arguments" warning.

 -- Robert Luberda <robert@debian.org>  Sun, 27 Jul 2008 13:06:38 +0200

upx-ucl (3.01-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix bashism in debian/rules (Closes: #478635)
  * Bump Standards-Version to 3.8.0.

 -- Chris Lamb <chris@chris-lamb.co.uk>  Sat, 07 Jun 2008 21:21:37 +0100

upx-ucl (3.01-2) unstable; urgency=low

  * Merge changes from experimental:
    + Standards-Version: 3.7.3 (no changes).
    + Move homepage url from Description to its own field.
  * Build with debhelper v6.
  * Remove debian revision from libucl-dev build dependency (lintian).
  * Change doc-base section to `File Management' (lintian).

 -- Robert Luberda <robert@debian.org>  Sat, 26 Apr 2008 18:45:42 +0200

upx-ucl (3.01-1) unstable; urgency=low

  * New upstream version.

 -- Robert Luberda <robert@debian.org>  Thu, 09 Aug 2007 22:59:19 +0200

upx-ucl (3.00-2) unstable; urgency=low

  * Fix FTBFS on big-endian archs (hppa, ia64,sparc).

 -- Robert Luberda <robert@debian.org>  Fri, 06 Jul 2007 09:03:34 +0200

upx-ucl (3.00-1) unstable; urgency=low

  * New upstream version (closes: #422910).

 -- Robert Luberda <robert@debian.org>  Sun, 20 May 2007 13:43:54 +0200

upx-ucl (2.03-3) unstable; urgency=low

  * Upload to unstable.
  * Fix FTBFS with gcc 4.3 (closes: #417676).

 -- Robert Luberda <robert@debian.org>  Mon, 23 Apr 2007 21:50:34 +0200

upx-ucl (2.03-2) experimental; urgency=low

  * Sync debian/rules with upx-ucl-beta 2.93-1.
  * dh_upx: Fix broken i386-linux architecture check.

 -- Robert Luberda <robert@debian.org>  Sat, 10 Mar 2007 22:12:32 +0100

upx-ucl (2.03-1) unstable; urgency=low

  * New upstream version.

 -- Robert Luberda <robert@debian.org>  Wed, 31 Jan 2007 00:45:25 +0100

upx-ucl (2.01-1) unstable; urgency=low

  * New upstream version.
  * Standards-Version: 3.7.2 (no changes).

 -- Robert Luberda <robert@debian.org>  Tue, 13 Jun 2006 21:23:23 +0200

upx-ucl (2.00-1) unstable; urgency=low

  * New upstream version:
    + support for a few new executable formats, like arm/pe, linux elf/amd64,
      linux elf/ppc32, mach/ppc32, bootable Linux kernels ("vmlinuz/386"),
      Playstation exes ("ps1/exe")
    + new options for compression tuning (e.g. '--brute')
    + improved win32/pe compatibility
    + direct ELF-to-memory decompression.
  * Update package description.
  * Add build dependency on zlib1g-dev, remove unneeded dependency on man-db.
  * Use debhelper v5.
  * Standards-Version: 3.7.0.

 -- Robert Luberda <robert@debian.org>  Mon,  1 May 2006 18:09:52 +0200

upx-ucl (1.25-5) unstable; urgency=low

  * debian/doc-base: change section to Apps/Tools (closes: #335075).

 -- Robert Luberda <robert@debian.org>  Sat, 22 Oct 2005 20:08:00 +0200

upx-ucl (1.25-4) unstable; urgency=low

  * Rebuild for g++ transition.
  * Standards-Version: 3.6.2 (no changes).

 -- Robert Luberda <robert@debian.org>  Sun,  7 Aug 2005 22:01:10 +0200

upx-ucl (1.25-3) unstable; urgency=low

  * Try to fix problem with compling on arm.

 -- Robert Luberda <robert@debian.org>  Sun, 10 Oct 2004 20:48:04 +0200

upx-ucl (1.25-2) unstable; urgency=low

  * Upload to unstable.
  * Fix typo in debian/watch file.

 -- Robert Luberda <robert@debian.org>  Tue, 28 Sep 2004 21:34:32 +0200

upx-ucl (1.25-1) experimental; urgency=low

  * New upstream version:
    + build with libucl-dev 1.03-1
  * Standards-Version: 3.6.1 (no changes).
  * Add debian/watch file.
  * Add lintian source override file for `cvsignore-file-in-source'.
  * Add homepage link to the package description.

 -- Robert Luberda <robert@debian.org>  Mon, 26 Jul 2004 21:00:43 +0200



=== debian/control ===
Source: upx-ucl
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Robert Luberda <robert@debian.org>
Standards-Version: 3.8.4
Build-Depends: debhelper (>= 7), libucl-dev (>= 1.03), zlib1g-dev (>= 1:1.1.4)

Package: upx-ucl
Architecture: any
Provides: upx, dh-upx
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: an efficient live-compressor for executables
 UPX is an advanced executable file compressor. UPX will typically
 reduce the file size of programs and DLLs by around 50%-70%, thus
 reducing disk space, network load times, download times etc. The
 current version can compress executables for DOS, Linux/ELF (i386,
 amd64, ppc32) and some other files for different OS.
 .
 NOTE: This package is based on the UCL library, which is licensed under GPL.
Homepage: http://upx.sourceforge.net/

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# This file is public domain software, originally written by Joey Hess. 
# $Id: rules 541 2009-10-15 10:54:57Z robert $ 
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export PATH := /home/robert/bin/gcc-4.4:$(PATH)

CC			:= gcc
CXX			:= g++
package			:= $(shell dh_listpackages)

BIG_ENDIAN_ARCHS	:= hppa ia64 sparc 
DEB_BUILD_ARCH		:= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

export DESTDIR		:= $(CURDIR)/debian/$(package)

CXXFLAGS		:= -DWITH_UCL -g
ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CXXFLAGS 	+= -O2
else
	CXXFLAGS 	+= -O0
endif


ifneq (,$(findstring $(DEB_BUILD_ARCH), $(BIG_ENDIAN_ARCHS)))
	CXXFLAGS 	+= -D__BIG_ENDIAN__=1
	CPPFLAGS 	+= -D__BIG_ENDIAN__=1
endif


ifeq (0,1)
	CXXFLAGS 	+= -I $(I)
	LDFLAGS 	+= -L $(L)
endif

ifeq (armel,$(DEB_BUILD_ARCH))
	# [asac] not thumb2 ready - use -marm
	CXXFLAGS	+= -marm
endif


build: build-stamp
build-stamp:
	dh_testdir

	# Add here commands to compile the package.
	@echo "Starting build process ($(DEB_BUILD_ARCH))"
	  UPX_UCLDIR=/none CC=$(CC) CXX=$(CXX) 	\
	  CXXFLAGS="$(CXXFLAGS)" 		\
	  CPPFLAGS="$(CPPFLAGS)"		\
	  LDFLAGS="$(LDFLAGS)" 			\
        make exeext="" target=linux all

	cd doc && mv upx.1 $(package).1
ifneq (, $(wildcard debian/dh_upx))
	pod2man -c " " -r "dh_upx" debian/dh_upx > doc/dh_upx.1
endif

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp

	# Add here commands to clean up after the build process.
	-make UPX_UCLDIR=/none \
			exeext="" \
			distclean
	rm -rf doc/*.1 doc/*.ps

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# Add here commands to install the package into debian/<packagename>
	install -pm 0755 src/upx $(DESTDIR)/usr/bin/$(package)
ifneq (, $(wildcard debian/dh_upx))
	install -pm 0755 debian/dh_upx $(DESTDIR)/usr/bin/
endif

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs NEWS
	dh_installdocs
#	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installcatalogs
#	dh_installpam
#	dh_installmime
#	dh_installinit
#	dh_installcron
#	dh_installinfo
#	dh_undocumented
	dh_installman doc/*.1
#	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_python
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## upx-ucl 3.07

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,7 @@
 #
 # UPX toplevel Makefile - needs GNU make 3.81 or better
+#
+# Copyright (C) 1996-2010 Markus Franz Xaver Johannes Oberhumer
 #
 
 MAKEFLAGS += -rR
@@ -36,13 +38,5 @@
 	$(MAKE) -C doc $@
 
 
-ifneq ($(wildcard .hg/data/.),)
-# automatically generate ChangeLog from local Mercurial repo
-ChangeLog:
-	hg log --style=changelog > $@
-.PHONY: ChangeLog
-endif
-
-
 .PHONY: default all mostlyclean clean distclean maintainer-clean

=== src/stub/src/arch/Makefile ===
# convenience Makefile
default %:
	$(MAKE) -C ../.. $@

=== debian/changelog ===
upx-ucl (3.07-4) experimental; urgency=low

  * Compile with the latest version of lzma-dev (closes: #452817):
    + add 02_lzma.patch for minor changes required to accomplish the above;
    + introduce build dependency on lzma-dev (>= 9.22).
  * 03_typos.patch, debian/doc-base: Fix typos found by lintian.
  * Remove leading article from package's description (lintian).
  * Bump Standards-Version to 3.9.2 (no changes required).

 -- Robert Luberda <robert@debian.org>  Tue, 13 Sep 2011 07:55:34 +0200

upx-ucl (3.07-3) unstable; urgency=low

  * debian/rules: use CPPFLAGS instead of CXXFLAGS for setting preprocessor
    macros to fix FTBFS on sparc introduced in previous upload.

 -- Robert Luberda <robert@debian.org>  Wed, 09 Feb 2011 08:21:54 +0100

upx-ucl (3.07-2) unstable; urgency=low

  * Upload to unstable.
  * Remove dh_upx, is not needed at all.
  * debian/rules:
    + provide build-indep, build-arch targets;
    + call dpkg-buildflags for getting CXXFLAGS and LDFLAGS;
    + use dh_auto_build and dh_auto_clean.

 -- Robert Luberda <robert@debian.org>  Tue, 08 Feb 2011 20:19:12 +0100

upx-ucl (3.07-1) experimental; urgency=low

  * New upstream release.
  * Build with debhelper v8.
  * Standards-Version: 3.9.1 (no changes).

 -- Robert Luberda <robert@debian.org>  Sun, 12 Sep 2010 16:44:13 +0200

=== debian/control ===
Source: upx-ucl
Section: utils
Priority: optional
Maintainer: Robert Luberda <robert@debian.org>
Standards-Version: 3.9.2
Build-Depends: debhelper (>= 8),
               libucl-dev (>= 1.03),
               lzma-dev (>= 9.22),
               zlib1g-dev (>= 1:1.1.4)

Package: upx-ucl
Architecture: any
Provides: upx
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: efficient live-compressor for executables
 UPX is an advanced executable file compressor. UPX will typically
 reduce the file size of programs and DLLs by around 50%-70%, thus
 reducing disk space, network load times, download times etc. The
 current version can compress executables for DOS, Linux/ELF (i386,
 amd64, ppc32) and some other files for different OS.
 .
 NOTE: This package is based on the UCL library, which is licensed under GPL.
Homepage: http://upx.sourceforge.net/

=== debian/rules ===
#!/usr/bin/make -f
# $Id: rules 563 2011-09-12 18:39:24Z robert $
# Sample debian/rules that uses debhelper.
# This file is public domain software, originally written by Joey Hess.

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

DH_AUTO_OPTIONS         := -v -Smakefile --parallel
package                 := $(shell dh_listpackages)


BIG_ENDIAN_ARCHS        := hppa ia64 sparc
DEB_BUILD_ARCH          := $(shell dpkg-architecture -qDEB_BUILD_ARCH)

export DESTDIR          := $(CURDIR)/debian/$(package)

export CC               := gcc
export CXX              := g++
export UPX_UCLDIR       := /none
export UPX_LZMADIR      := /usr/include/lzma
export CXXFLAGS         := $(shell dpkg-buildflags --get CXXFLAGS)
export CPPFLAGS         := -DWITH_UCL $(shell dpkg-buildflags --get CPPFLAGS)
export LDFLAGS          := $(shell dpkg-buildflags --get LDFLAGS)
ifneq (,$(findstring $(DEB_BUILD_ARCH), $(BIG_ENDIAN_ARCHS)))
        CPPFLAGS        += -D__BIG_ENDIAN__=1
endif


build-arch: build-stamp
build-stamp:
	dh_testdir

	# Add here commands to compile the package.
	@echo "Starting build process ($(DEB_BUILD_ARCH))"
	dh_auto_build $(DH_AUTO_OPTIONS) --     \
	              exeext=""                 \
	              target=linux              \
	              all

	cd doc && mv upx.1 $(package).1

	touch "$@"

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp

	dh_auto_clean $(DH_AUTO_OPTIONS) -- \
	                exeext=""
	rm -rf doc/*.1 doc/*.ps

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	install -pm 0755 src/upx $(DESTDIR)/usr/bin/$(package)


# Build architecture-dependent files here.
binary-arch: build-arch install
	dh_testdir
	dh_testroot
	dh_installchangelogs NEWS
	dh_installdocs
#	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installcatalogs
#	dh_installpam
#	dh_installmime
#	dh_installinit
#	dh_installcron
#	dh_installinfo
#	dh_undocumented
	dh_installman doc/*.1
#	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_python
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary-indep build-indep:       # Nothing to do

binary: binary-indep binary-arch
build:  build-indep  build-arch

.PHONY: clean         install                                   \
	build-indep   build-arch   build                        \
	binary-indep  binary-arch  binary

.DEFAULT_GOAL := binary
